type bioperator = Add|Sub|Mul|Div|Mod|Le|Se|Eq|Neq|Larger|Smaller|And|Or(*binary operators*)
type unioperator = Uminus|Not (*uniary operators*)
type vari_type=Int|Str|Flo|Bol|Lin|Cir|Poi|Void (*variable types*)

     
type expr = (*expressions*)
    Binop of expr * bioperator * expr (*a + 2*)
  | Integer of int (*42*)
  | Float of float(*3.2*)
  | Bool of bool (*True*)
  | String of string(*'abcdefg'*)
  | Uniop of unioperator*expr(*-2 or ~True*)
  | Assign of string*expr (*a=2*)
  | Id of string (*identifiers*)
  | Call of  string * expr list(*function call*)
  | Property of string*string(*object property*)
  | Property_Call of string*string*expr list
  | Noexpr
  | Library_Call of string*string*expr list

type var_req={(*where a variable is required, but not declared,like in formal list return value of a function and *)
	v_type:vari_type;
	v_name:string;
}

type var_decl={(*variable declaration*)
	v_type:vari_type;
    v_name: string;
	init_value: expr;
}

type stmt = (* Statements *)
    Expr of expr 
  | Return of expr 
  | If of expr * stmt list * stmt list* stmt list
  | For of expr * expr * expr * stmt list
  | While of expr * stmt list
  | Var_dec of var_decl
  | Func_dec of func_decl
  | Break
  | Continue
  | Pass
  | Elif of expr * stmt list
and func_decl = {(*function declaration*)
  return_type : var_req;
  fname : string;
  formals : var_req list;
  body : stmt list;
}

type program = stmt list(*program*)